! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module add_mod

  use Dal
  use Param

  implicit none

  real(single) :: xPixelSize = 0.26, yPixelSize = 0.26, xOrg = 0, yOrg = 0

contains

  subroutine add

    type(DataSetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: xCol, yCol, rawXCol, rawYCol
    integer(int32), dimension(:), pointer :: rawX, rawY
    real(single), dimension(:), pointer :: x, y

    set = dataSet(stringParameter("set"),Modify)

    tab = table(set,stringParameter("table"))

    rawXCol = column(tab,stringParameter("rawX"),Read)
    rawX => int32Data(rawXCol)
    rawYCol = column(tab,stringParameter("rawY"),Read)
    rawY => int32Data(rawYCol)

    xCol = addColumn(tab,"x",Real32,"mm")
    x => real32Data(xCol)
    yCol = addColumn(tab,"y",Real32,"mm")
    y => real32Data(yCol)

    x = rawX * xPixelSize + xOrg
    y = rawY * yPixelSize + yOrg

    call release(rawXCol)
    call release(rawYCol)
    call release(xCol)
    call release(yCol)
    call release(set)

  end subroutine add

end module add_mod
