! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module generate_mod

use Dal
use Param

implicit none

contains

  subroutine generate

    type(DataSetT) :: set
    type(TableT) :: table
    type(ColumnT) :: idCol, rawXCol, rawYCol, phCol, selectedCol
    integer(int32), dimension(:), pointer :: id, rawX, rawY, ph
    integer(int16), dimension(:), pointer :: selected

    set = dataSet(stringParameter("set"),Create)

    table = addTable(set,"events",1000)

    idCol = addColumn(table,"id",integer32,"billpence")
    id => int32Data(idCol)
    id = 100
    call release(idCol)

    rawXCol = addColumn(table,"rawX",integer32,"pixels")
    rawX => int32Data(rawXCol)
    rawX = 200
    call release(rawXCol)

    rawYCol = addColumn(table,"rawY",integer32,"pixels")
    rawY => int32Data(rawYCol)
    rawY = 200
    call release(rawYCol)

    phCol = addColumn(table,"ph",integer32,"au")
    ph => int32Data(phCol)
    ph = 300
    call release(phCol)

    selectedCol = addColumn(table,"selected",integer16,"billpence")
    selected => int16Data(selectedCol)
    selected = 1
    call release(selectedCol)

    call release(table)
    call release(set)

  end subroutine generate

end module generate_mod
